package org.apache.commons.lang3.function;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.util.Objects;
import org.apache.commons.lang3.function.FailableFunction;

@FunctionalInterface
public interface FailableBiFunction<T, U, R, E extends Throwable> {
  public static final org.apache.commons.lang3.function.FailableBiFunction NOP = (t, u) -> null;
  
  static <T, U, R, E extends Throwable> org.apache.commons.lang3.function.FailableBiFunction<T, U, R, E> nop() {
    return NOP;
  }
  
  default <V> org.apache.commons.lang3.function.FailableBiFunction<T, U, V, E> andThen(FailableFunction<? super R, ? extends V, E> after) {
    Objects.requireNonNull(after);
    return (t, u) -> after.apply(apply((T)t, (U)u));
  }
  
  R apply(T paramT, U paramU) throws E;
}
